import { message } from "antd/lib/index";
import { Button, Popconfirm, Row, Col, Form, Input, Select, Table } from 'antd';
import React from 'react';
import { initFilter, extendRule, extendInclude, setDataFieldValue, guid, initQueryFilter } from "../../../utils/common";
import ReactToPrint from "react-to-print";
import styles from '../HI/StepForm.css';
import config from "../../../config";
import XLSX from 'xlsx';
import { connect } from 'dva';

class FO003ShowPrint extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            data: null,
            enumData: null,
            BtnAgreeDisplay: 'none',
            isFinished: 'none',
            isMobile: false
        };
    };

    componentDidMount() {
        if (window.navigator.userAgent.indexOf("Windows") < 1) {
            this.setState({ isMobile: true })
        }
        if (this.props.data?.id)
            this.loadData(this.props.data?.id);
    }

    componentWillReceiveProps(NextProps) {
        if (NextProps.data?.id && this.props.data?.id != NextProps.data?.id) {
            this.loadData(NextProps.data?.id);
        }
    }


    onTableBtnAgree() {
        this.props.dispatch({
            type: 'app/getDataByPost',
            url: 'FO/FOPreShiftMeetingRecord/PersonalAgree',
            payload: {
                ID: this.props.data.id,
                TaskID: this.props.data.TaskID,
                IgnoreDataRule : true
            },
            onComplete: (ret) => {
                if (ret) {
                    message.success('签到成功！');
                    this.setState({ BtnAgreeDisplay: 'none' })
                    this.BtnClose();
                }
            }
        })
    }

    BtnClose = () => {
        if (typeof this.props.data.onCancel != "undefined" && typeof this.props.data.onCancel == 'function')
            this.props.data.onCancel();
    }

    loadData = (dataId) => {
        let json = initFilter(this.props.login.OrgId);
        extendRule(json, 'ID', 1, dataId);
        extendInclude(json, 'Nav_Team');
        extendInclude(json, 'Nav_Class');
        extendInclude(json, 'Nav_User');
        extendInclude(json, 'Nav_Users.Nav_User.Nav_UserSignFiles.Nav_ImgFile.Nav_File');
        extendInclude(json, 'Nav_Files.Nav_ImgFile.Nav_File');
        this.props.dispatch({
            type: 'app/getDataByPost',
            payload: json,
            url: 'FO/PreShiftMeetingRecord/Get',
            onComplete: (ret) => {
                if (ret) {
                    this.setState({ data: ret })
                    if (this.props.data.tableKey == "2" || this.props.data.tableKey == undefined) {
                        this.setState({ BtnAgreeDisplay: 'none' })
                    } else {
                        this.setState({ BtnAgreeDisplay: 'inline' })
                    }
                    //归档才显示打印和导出按钮
                    if (ret.PRE_MEETING_STATUS == 5) {
                        this.setState({ isFinished: 'inline' })
                    }
                    //     if (ret.ID) {
                    //         this.props.dispatch({
                    //             type: 'app/getDataByPost',
                    //             url: 'FO/FOPreShiftMeetingRecord/GetPreShiftMeetingRecord',
                    //             payload: {
                    //                 ID: dataId,
                    //             },
                    //             onComplete: (result) => {
                    //                 if (result != null) {
                    //                     if (result) {
                    //                         this.setState({ BtnAgreeDisplay: 'inline' })
                    //                     }else{
                    //                         this.setState({ BtnAgreeDisplay: 'none' })
                    //                     }
                    //                 }
                    //             }
                    //         })
                    //     }
                }else
                { message.error('数据加载获取失败，请联系管理员排查!');}
            }
        });
    }

    onTableBtnExport() {
        let TableWrap = document.getElementById('tableId' + this.props.data.id);
        let Table = TableWrap.getElementsByTagName('table')[0];
        const wb = XLSX.utils.table_to_book(Table);
        XLSX.writeFile(wb, this.props.data.Nav_Department.NAME + ".xlsx")
    }

    render() {
        const { data, isMobile } = this.state;
        return <div>
            <div style={{ marginTop: '10px' }}>
                <ReactToPrint
                    trigger={() => <Button type={'default'} icon={'printer'} style={{ marginLeft: '20px', display: this.state.isFinished }} >打印</Button>}
                    content={() => this.componentRef}
                    pageStyle=".printDIV { padding:0 40px;} img{width :120px}"
                />
                <Button style={{ marginLeft: '20px', display: this.state.isFinished }} onClick={() => this.onTableBtnExport()} icon="export" >导出</Button>
                <Button style={{ marginLeft: isMobile ? '0' : '20px', display: this.state.BtnAgreeDisplay }} onClick={() => this.onTableBtnAgree()} icon="check" >签到</Button>
            </div>


            {/* 班前会议记录表 */}
            <div ref={el => (this.componentRef = el)} id={'tableId' + this.props.data.id} style={{ padding: isMobile ? '0px 0px 20px 0px' : '20px' }} className="printDIV">

                <h1 style={{ textAlign: 'center' }}>班前会议记录表</h1>
                {
                    data ? <table style={{ width: '100%', textAlign: 'center', borderTop: '1px solid #333', borderLeft: '1px solid #333' }} className={styles.PrintForm}>
                        <tbody>
                            <tr>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>会议时间</td>
                                <td colSpan={3} rowSpan={1}>{data.MEETING_TIME.substring(0, 10)}</td>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>班组名称</td>
                                <td colSpan={3} rowSpan={1}>{data.Nav_Team ? data.Nav_Team.NAME : ''}</td>
                            </tr>
                            <tr>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>班次</td>
                                <td colSpan={3} rowSpan={1}>{data.Nav_Class ? data.Nav_Class.NAME : ''}</td>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>班组长/主持人</td>
                                <td colSpan={3} rowSpan={1}>{data.Nav_User ? data.Nav_User.NAME : ''}</td>
                            </tr>
                            <tr>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>参会人员</td>
                                <td colSpan={8} rowSpan={1} >{
                                    data.Nav_Users && data.Nav_Users.map((item, i) => {
                                        if (i == (data.Nav_Users.length - 1)) {
                                            if (item.DEAL_STATUS == 0)
                                                return <label style={{ color: 'red' }} title='未签到'> {item.Nav_User.NAME}</label>
                                            else
                                                return item.Nav_User.NAME
                                        } else {
                                            if (item.DEAL_STATUS == 0)
                                                return <label style={{ color: 'red' }} title='未签到'>{item.Nav_User.NAME + '  '}</label>
                                            else
                                                return item.Nav_User.NAME + '  '
                                        }
                                    })
                                }</td>
                            </tr>
                            <tr>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>班组当班工作内容</td>
                                <td colSpan={8} rowSpan={1}>{data.JOB_CONTENT}</td>
                            </tr>
                            <tr>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>安全注意事项及防护措施</td>
                                <td colSpan={8} rowSpan={1}>{data.PROTECT_MEASURE}</td>
                            </tr>
                            <tr>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>其他内容</td>
                                <td colSpan={8} rowSpan={1}>{data.OTHER_CONTENT}</td>
                            </tr>
                            <tr>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>附件</td>
                                <td colSpan={8} rowSpan={1}>{
                                    data.Nav_Files && data.Nav_Files.map((item, i) => {
                                        return <a width={'20%'} title={item.Nav_ImgFile.FILE_NAME} target='_blank' href={config.picServerHost + item.Nav_ImgFile.Nav_File.FILE_PATH} >{item.Nav_ImgFile.FILE_NAME} </a>
                                    })
                                }
                                </td>
                            </tr>
                            <tr>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>会议签到区</td>
                                <td colSpan={8} rowSpan={1}>{
                                    data.Nav_Users && data.Nav_Users.map((item, i) => {
                                        if (item.DEAL_STATUS == 1) {
                                            if (item.Nav_User != null && item.Nav_User.Nav_UserSignFiles[0] != null)
                                                return <img width={'150px'} alt={item.Nav_User.NAME} src={config.picServerHost + item.Nav_User.Nav_UserSignFiles[0].Nav_ImgFile.Nav_File.FILE_PATH} />
                                            else
                                                return <img width={'150px'} title={item.Nav_User.NAME} />
                                        }
                                    })
                                }
                                </td>
                            </tr>
                        </tbody>
                    </table> : null
                }
            </div>
        </div>
    }

}
export default connect(({ login }) => ({ login }))(FO003ShowPrint) 